/*
 * SPDX-FileCopyrightText: (C) 2025 Zephyr Lykos <self@mochaa.ws>
 *
 * SPDX-License-Identifier: 0BSD
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
 * REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
 * INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

#include <combaseapi.h>
#include <exdisp.h>

int wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPWSTR lpCmdLine,
             int nShowCmd) {
  HRESULT hr = CoInitialize(NULL);
  if (FAILED(hr))
    goto fail;

  IWebBrowser2 *pIE = NULL;
  hr = CoCreateInstance(&CLSID_InternetExplorer, NULL, CLSCTX_LOCAL_SERVER,
                        &IID_IWebBrowser2, (void **)&pIE);
  if (FAILED(hr))
    goto fail;

  pIE->lpVtbl->put_Visible(pIE, VARIANT_TRUE);
  pIE->lpVtbl->Release(pIE);
  CoUninitialize();

  ExitProcess(EXIT_SUCCESS);

fail:
  ExitProcess(EXIT_FAILURE);
}
